
;Small Window - DednDave, 4-2011

        .XCREF
        .NOLIST
        INCLUDE    \masm32\include\masm32rt.inc
        INCLUDE    SmallWin.inc
        .LIST

;###############################################################################################

Rgb2Cr  MACRO   red,green,blue
        EXITM   % (blue SHL 16) OR (green SHL 8) OR red
        ENDM

;###############################################################################################

        .DATA

szClassName db 'SmallWindowClass',0
szAppName   db 'Small Window',0

;------------------------------

        .DATA?

        ALIGN   4

hInstance     dd ?
hWin          dd ?
hbrBackground dd ?

;###############################################################################################

        .CODE

        OPTION  PROLOGUE:None
        OPTION  EPILOGUE:None

        ALIGN   16

WndProc PROC    hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

;------------------------------

        mov     ecx,[esp+8]                             ;uMsg
        cmp     ecx,WM_CLOSE
        jz      WndPrY

        cmp     ecx,WM_DESTROY
        jz      WndPrZ

;------------------------------

        JMP     DefWindowProc

;------------------------------

WndPr0: xor     eax,eax
        ret     16

;------------------------------

;WM_CLOSE

WndPrY: INVOKE  DestroyWindow,[esp+4]                   ;hWnd
        INVOKE  DeleteObject,hbrBackground
        jmp     WndPr0

;------------------------------

;WM_DESTROY

WndPrZ: INVOKE  PostQuitMessage,NULL
        jmp     WndPr0

;------------------------------

WndProc ENDP

        OPTION  PROLOGUE:PrologueDef
        OPTION  EPILOGUE:EpilogueDef

;***********************************************************************************************

_main   PROC

;------------------------------

;initialize common controls

        xor     edi,edi                                 ;EDI = 0
        push    edi
        push    sizeof INITCOMMONCONTROLSEX
        INVOKE  InitCommonControlsEx,esp

;------------------------------

;register the window class

        INVOKE  GetModuleHandle,edi
        mov     hInstance,eax
        xchg    eax,ebp                                 ;EBP = hInstance
        INVOKE  LoadIcon,ebp,IDI_ICON
        xchg    eax,ebx                                 ;EBX = hIcon

;create background brush

        INVOKE  CreateSolidBrush,Rgb2Cr(128,0,0)
        mov     hbrBackground,eax

        INVOKE  LoadCursor,edi,IDC_ARROW                ;EAX = hCursor
        mov     esi,offset szClassName                  ;ESI = offset szClassName
        push    ebx                                     ;WNDCLASSEX.hIconSm
        push    esi                                     ;WNDCLASSEX.lpszClassName
        push    edi                                     ;WNDCLASSEX.lpszMenuName
        push    hbrBackground                           ;WNDCLASSEX.hbrBackground
        push    eax                                     ;WNDCLASSEX.hCursor
        push    ebx                                     ;WNDCLASSEX.hIcon
        push    ebp                                     ;WNDCLASSEX.hInstance
        push    edi                                     ;WNDCLASSEX.cbWndExtra
        push    edi                                     ;WNDCLASSEX.cbClsExtra
        push    WndProc                                 ;WNDCLASSEX.lpfnWndProc
        push    edi                                     ;WNDCLASSEX.style
        push    sizeof WNDCLASSEX                       ;WNDCLASSEX.cbSize
        INVOKE  RegisterClassEx,esp

;------------------------------

;create the window

        INVOKE  CreateWindowEx,edi,esi,offset szAppName,
                WS_OVERLAPPEDWINDOW or WS_VISIBLE or WS_CLIPCHILDREN,
                CW_USEDEFAULT,SW_SHOWNORMAL,400,300,edi,edi,ebp,edi
        mov     hWin,eax
        INVOKE  UpdateWindow,eax

;------------------------------

;message loop

        mov     ebp,esp                                 ;EBP = offset MSG
        jmp short mLoop1

mLoop0: INVOKE  TranslateMessage,ebp
        INVOKE  DispatchMessage,ebp

mLoop1: INVOKE  GetMessage,ebp,edi,edi,edi
        inc     eax                                     ;exit only
        shr     eax,1                                   ;if 0 or -1
        jnz     mLoop0                                  ;otherwise, we loop

;------------------------------

;exit program

        pop     eax                                     ;MSG.wParam is the parm for ExitProcess
        JMP     ExitProcess

_main   ENDP

;###############################################################################################

        END     _main

